#include "diawxxt.h"

class mywxFrame: public wxFrame{
public:
	MAINFORM *mf;
	mywxFrame (wxFrame *_parent, MAINFORM *_mf, int x, int y, long style)
		: wxFrame(_parent,NULL, x, y, 400, 300,style)
	{
		mf = _mf;
	}
	void OnSize(){
		mf->mainlayout();
	}
	Bool OnClose(){
		mf->escape();
		return FALSE;
	}
	#if 0
    void  OnMenuSelect(int id){
		fprintf (stderr,"menuselect id %d\n",id);
	}
    void OnItemEvent(wxItem *item, wxMouseEvent &event){
		fprintf (stderr,"itemevent %p\n",item);
	}
	#endif
	void OnMenuCommand(int id){
		char path[300];
		formbase_getabspath(mf,path);
		remadmin_setcursor (cursor_wait);
		mf->dump();
		fprintf (mform_fout,"menubar %s %d\n",path,id);
		fflush (mform_fout);
		// fprintf (stderr,"menubar %s %d\n",path,id);
	}
	
};

PUBLIC void MAINFORM::mainlayout()
{
	//fprintf (stderr,"mainlayout\n");
	doalllayout();
	int w,h;
	GetSize (&w,&h);
	wxMenuBar *bar = fram->GetMenuBar();
	int toph = 0;
	if (bar != NULL){
		int w;
		bar->GetSize(&w,&toph);
	}
	fram->SetSize (-1,-1,w,h+toph);
	//fprintf (stderr,"fin mainlayout\n");
}

PRIVATE void MAINFORM::init(
	wxFrame *_parent,
	int x,
	int y,
	long style)
{
	enteraction = NULL;
	fram = new mywxFrame(_parent,this,x,y,style);
	Create (fram);
}
PRIVATE void MAINFORM::init(const char *type)
{
	int opt = wxSDI | wxDEFAULT_FRAME;
	int x = -1,y=-1;
	if (strcmp(type,"error")==0){
		x = 300; y=300;
		opt = wxTRANSIENT;
	}else if (strcmp(type,"notice")==0){
		x = 300; y=300;
		opt = wxTRANSIENT;
	}else if (strcmp(type,"popup")==0){
		x = 300; y=300;
		opt = wxTRANSIENT;
	}
	init (NULL,x,y,opt);
}
PUBLIC MAINFORM::MAINFORM(
	const char *_id,
	const char *_titre,
	const char *type)
	: MFORM (_id)
{
	init(type);
	setTitle (_titre);
}
PUBLIC MAINFORM::MAINFORM(const char *_id)
	: MFORM(_id)
{
	init("");
}
PUBLIC MAINFORM::MAINFORM(
	wxFrame *_parent,
	const char *_id,
	int x,
	int y,
	long style)
	: MFORM(_id)
{
	init(_parent,x,y,style);
}
PUBLIC MAINFORM::~MAINFORM()
{
	free (enteraction);
}

PUBLIC void MAINFORM::reset()
{
	MFORM::reset();
}


PUBLIC void MAINFORM::Popup()
{
	if (pref_width == -1) mainlayout();
	fram->Fit();
	fram->Show(TRUE);
}
PUBLIC void MAINFORM::setTitle(const char *title)
{
	fram->SetTitle((char*)title);
}
PUBLIC VIRTUAL void MAINFORM::dispose()
{
	wxPostDelete(fram);
}

PUBLIC void MAINFORM::hide()
{
	fram->Show(FALSE);
}

PUBLIC void MAINFORM::escape()
{
	char path[300];
	formbase_getabspath(this,path);
	fprintf (mform_fout,"action %s X\n",path);
	fflush (mform_fout);
}

PUBLIC void MAINFORM::setenteraction(const char *str)
{
	free (enteraction);
	enteraction = strdup(str);
}
PUBLIC const char *MAINFORM::getenteraction()
{
	return enteraction;
}
/*
	Select the mouse cursor
*/
PUBLIC void MAINFORM::setcursor(wxCursor *cur)
{
	fram->SetCursor(cur);
}



